var Bootstrap = require('./bootstrap');
var defineFunctions = Bootstrap.defineFunctions;

var reduceDescriptors = require('./reduceDescriptors')

function assignValue(target, key, value) {
  target[key] = value;
}
  
function assignDefaultValue(target, key, value) {
  if (key in target)
    return;
  assignValue(target, key, value);
}
  
// assign(target, source)
// assignDefaults(target, source)
// assignDescriptors(keys, target, source)
// assignDescriptorsDefaults(keys, target, source)
defineFunctions(this, {
  
  assign: function(target, source) {
    return reduceDescriptors(assignValue, undefined, target, source);
  },
  
  assignDefaults: function(target, source) {
    return reduceDescriptors(assignDefaultValue, undefined, target, source);
  },

  assignDescriptors: function(keys, target, source) {
    return reduceDescriptors(assignValue, keys, target, source);
  },
  
  assignDescriptorsDefaults: function(keys, target, source) {
    return reduceDescriptors(assignDefaultValue, keys, target, source);
  },
});