var Bootstrap = require('./bootstrap');
var defineFunctions = Bootstrap.defineFunctions;

var reduceDescriptors = require('./reduceDescriptors');

// compose(f, g)
// composeValue(target, key, value)
// composeDescriptors(keys, target, source)
defineFunctions(this, {

  compose: function(f, g) {
    if (!g && !f)
      return undefined;
    
    if (!f) 
      return g;    
    
    if (!g) 
      return f;
    
    return function() {
      arguments[arguments.length - 1] = f.apply(this, arguments);
      return g.apply(this, arguments);
    }
  },  

  composeValue: function(target, key, value) {
    target[key] = exports.compose(target[key], value);
  },

  composeDescriptors: function(keys, target, source) {
    return reduceDescriptors(exports.composeValue, keys, target, source);
  },
});