var bootstrap = require('./bootstrap');
var defineConstHiddenProperty = bootstrap.defineConstHiddenProperty;

var reflection = require('./reflection');
var isUndefined = reflection.isUndefined;
var isArrayLike = reflection.isArrayLike;

function flatten_(result, action, values) {
  if (isUndefined(values))
    return;
  
  if (isArrayLike(values)) {
    for (var i = values.start || 0; i < values.length; i++)
      flatten_.call(this, result, action, values[i]);
    return;
  }

  result.push(action.call(this, values));    
}

function flatten(action, values) {
  var result = [ ];
  flatten_.call(this, result, action, values);
  return result;
}

defineConstHiddenProperty(module, 'exports', flatten);
