var Bootstrap = require('./bootstrap');
var defineFunctions = Bootstrap.defineFunctions;

var String = require('./string');
var capitalize = String.capitalize;
var isCapitalized = String.isCapitalized;
var decapitalize = String.decapitalize;

var singularOfDictionary = { };
var pluralOfDictionary = { };

function _singularOrPluralOf(value, map) {
  if (value in map)
    return map[value];
  
  var key = Object.keys(map).find(function(key) {
    return value.endsWith(key); 
  });
      
  if (key)
    return value.slice(0, value.length - key.length) + map[key];
        
  return null;
}

function singularOrPluralOf(value, map) {
  var wasCapitalized = isCapitalized(value);
  if (wasCapitalized)
    value = decapitalize(value);
  
  var result = _singularOrPluralOf(value, map);
  if (result && wasCapitalized)
    result = capitalize(result);
        
  return result;
}

// defineSingularPlural(singular, plural)
// singularOf(plural)
// pluralOf(singular)
defineFunctions(this, {
  
  defineSingularPlural: function(singular, plural) {
    // lowercase
    singularOfDictionary[plural] = singular;
    pluralOfDictionary[singular] = plural;
    
    // uppercase
    singular = capitalize(singular);
    plural = capitalize(plural);
    singularOfDictionary[plural] = singular;
    pluralOfDictionary[singular] = plural;
  },
  
  singularOf: function(plural) {
    return singularOrPluralOf(plural, singularOfDictionary) ||
      plural.substring(0, plural.length - 1);      
  },

  pluralOf: function(singular) {
    return singularOrPluralOf(singular, pluralOfDictionary) ||
      singular + 's';
  }
});