var Bootstrap = require('./bootstrap');
var defineConstHiddenProperty = Bootstrap.defineConstHiddenProperty;

var Reflection = require('./reflection');
var isObjectLiteral = Reflection.isObjectLiteral;

var flatten = require('./flatten');

function reduceDescriptors(action, keys, target/*, ... */) { 
  
  arguments.start = 3;
  flatten(function(descriptor) {
    
    for (var key in descriptor) {
      if (keys && !(key in keys))
        continue;
      
      var value = descriptor[key];
      var reducedValue = target[key];
      
      if (isObjectLiteral(value) && isObjectLiteral(reducedValue))
        // walk tree
        reduceDescriptors(action, keys ? keys[key] : undefined, reducedValue, value);
      else
        // act on leaf
        action(target, key, value);
    }     
  }, arguments);    
  
  return target;
};

defineConstHiddenProperty(module, "exports", reduceDescriptors);