var Bootstrap = require('./bootstrap');
var defineFunctions = Bootstrap.defineFunctions;

// reflection
defineFunctions(this, {
  isUndefined: function(o) { return o === undefined; },
  isNull: function(o) { return o === null; },
  isNullOrUndefined: function(o) { return exports.isNull(o) || exports.isUndefined(o); },

  isString: function(o) { return typeof o == 'string'; },
  isNonEmptyString: function(o) { return exports.isString(o) && o.length > 0; },
  isBoolean: function(o) { return typeof o == 'boolean'; },
  isNumber: function(o) { return typeof o == 'number'; },
  isFunction: function(o) { return typeof o == 'function'; },
  isNamedFunction: function(o) { return exports.isFunction(o) && exports.isNonEmptyString(o.name); },
  isObject: function(o) { return (typeof o == 'object' && !exports.isNull(o)) || exports.isFunction(o); },

  hasProperty: function(o, name) { return exports.isObject(o) && name in o; },
  isArray: function(o) { return Array.isArray(o); },
  isArrayLike: function (o) {
    if (exports.isArray(o))
      return true;
    
    if (exports.isFunction(o))
      return false;
    
    return exports.hasProperty(o, 'length');
  },
  
  isObjectLiteral: function(o) {
    return typeof o == 'object' && o != null && o.constructor == Object;
  }
});