var Bootstrap = require('./bootstrap');
var defineFunctions = Bootstrap.defineFunctions;

var Reflection = require('./reflection');
var isString = Reflection.isString;

// isLowerCase(value, index)
// isUpperCase(value, index)
// isCapitalized(value)
// capitalize(value)
// deCapitalize(value)
// endsWith(value, match)
defineFunctions(this, {

  isLowerCase: function(value, index) {
    if (!isString(value) || index >= value.length)
      return false;
    
    return value.charAt(index).toLowerCase() == value[index];
  },

  isUpperCase: function(value, index) {
    if (!isString(value) || index >= value.length)
      return false;
    
    return value.charAt(index).toUpperCase() == value[index];
  },

  isCapitalized: function(value) {
    return exports.isUpperCase(value, 0);
  },

  capitalize: function(value) {    
    if (exports.isCapitalized(value))
      return value;
    
    return value.charAt(0).toUpperCase() + value.substring(1, value.length);
  },

  decapitalize: function(value) {
    if (!exports.isCapitalized(value))
      return value;
    
    return value.charAt(0).toLowerCase() + value.substring(1, value.length);
  },
});